<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Student_Subject extends Controller_UserEnvi {

    public function action_show()
    {
        // ЛОГИКА
        $db = new Model_Student;
        $id = $this->request->param('id');
        
        $discipline = $db->getDisciplineMap($this->UserInfo['StudentID'], $id);
        $info = $db->getDisciplineInfoByID($id)->offsetGet(0);
        
        // Информация о предмете
        $subject['Title'] = $info['SubjectName'];
        if($info['ExamType'] == 'exam')
        {
            $subject['Control'] = 'Экзамен';
        }
        elseif($info['ExamType'] == 'credit')
        {
            $subject['Control'] = 'Зачет';
        }
        $subject['LectureHours'] = $info['LectionCount'];
        $subject['SeminarHours'] = $info['PracticeCount'];
        $subject['Teachers'] = $this->getTeachersForDiscipline($id);
        
        // Учебная карта дисциплины
        $disciplineHandled = array();
        $rate = 0; $maxRate = 0; $i = 0; $id = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleID'] != $id)
            {
                $i++;
                $id = $row['ModuleID'];
            }
            if(!isset($disciplineHandled[$i]['SubmodulesCount']))
            {
                $disciplineHandled[$i]['SubmodulesCount'] = 0;
                $disciplineHandled[$i]['Rate'] = 0;
                $disciplineHandled[$i]['MaxRate'] = 0;
            }
            $j = $disciplineHandled[$i]['SubmodulesCount'] += 1;
            $disciplineHandled[$i]['Rate'] += (int) $row['Rate'];
            $disciplineHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $disciplineHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $disciplineHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $disciplineHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $disciplineHandled[$i][$j]['Rate'] = (int) $row['Rate'];
            $disciplineHandled[$i][$j]['Date'] = $row['Date'];
            $disciplineHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $rate += $row['Rate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['Rate'] = (int) $rate;
        $disciplineHandled['MaxRate'] = (int) $maxRate;
        
        // ПРЕДСТАВЛЕНИЕ 
        $twig = Twig::factory('student/subject');
        $twig->User = $this->UserInfo;
        $twig->Subject = $subject;
        $twig->discipline = $disciplineHandled;
        $this->response->body($twig);
    }
    
    protected function getTeachersForDiscipline($id) {
        $model = new Model_Student;
        $teachers = $model->getTeachersForDiscipline($id);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++;
            $teachersHandled[$i] = $teacher['TeacherLast'].' '.$teacher['TeacherFirst'].' ';
            if(!empty($teacher['TeacherSecond']))
            {
                $teachersHandled[$i] .= $teacher['TeacherSecond'];
            }
        }
        return $teachersHandled;
    }        
}          